unit ClaReg;

interface
 Uses SysUtils, Classes, Windows, Messages, Graphics, Controls, Forms, Dialogs,
      Clarion;

 procedure Register;

implementation

uses DesignIntf, DesignEditors, DBReg;

type
  TTableNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
    procedure GetValueList(List: TStringList);
  end;

function TTableNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result:=[paValueList, paMultiSelect]
end;

procedure TTableNameProperty.GetValues(Proc: TGetStrProc);
var
  i: Integer;
  Values: TStringList;
begin
  Values:=TStringList.Create;
  try
    GetValueList(Values);
    for i:=0 to Values.Count-1 do Proc(Values[i])
  finally
    Values.Free
  end
end;

procedure TTableNameProperty.GetValueList(List: TStringList);
var F: TSearchRec;
    FN: String;
begin
  List.Clear;
  FN:=(GetComponent(0) as TClarionTable).DatabaseName;
  if FN<>'' then FN:=IncludeTrailingPathDelimiter(FN);
  FN:=FN+'*.DAT';

  List.Sorted:= true;
  if SysUtils.FindFirst(FN, faAnyFile, F)=0 then
   repeat
     List.Add(F.Name)
   until SysUtils.FindNext(F)<>0;
  SysUtils.FindClose(F)
end;

procedure Register;
begin
  RegisterComponents('Data Access', [TClarionTable]);
  RegisterPropertyEditor(TypeInfo(TFileName), TClarionTable, 'TableName', TTableNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TClarionTable, 'IndexName', TIndexNameProperty);
  RegisterPropertyEditor(TypeInfo(string), TClarionTable, 'IndexFieldNames', TIndexFieldNamesProperty);
end;

end.
